/**************************************************************************
Project name    :       pinza.c
Purpose         :       gestione robot pinzatore
Creation date   :       03/06/92
Author          :       F. Mondada
History.        :       
***************************************************************************/

#include        <stdio.h>
#include        <string.h>
/*#include      <math.h>*/

#define K_RADIUS        28              /* mm */

#ifndef ROTATION_SPEED
#define ROTATION_SPEED 5
#endif

#ifndef APPROACH_SPEED
#define APPROACH_SPEED 2
#endif


int32           gripped, direction;
int32           deltat=200, process_id;
int32           angle, x, cm, imp_offset, home;

int32 sign(int32 value)
{
  if(value<0)
    return(-1);
  else
    return(1);
}

int32 iabs(int32 value)
{
  if(value<0)
    return(-value);
  else
    return(value);
}


int32 get_elevation()
{
  uint8 command[50], response[50];
  int32 status;

  command[0] = (uint8)1;	/* ID tourelle */
  command[1] = (uint8)2;	/* nbr bytes utiles */

  command[2] = (uint8)'H';
  command[3] = (uint8)1;
  
  do
    {
      tim_suspend_task(20);
      status = msg_send_message(command, 4);
    }
  while(status!=0); 

  do
    {
      status = msg_receive_message(response, 2); 
    }
  while(status!=0); 

  return (int32)response[1];
}

int32 get_serrage()
{
  uint8 command[50], response[50];
  int32 status;

  command[0] = (uint8)1;	/* ID tourelle */
  command[1] = (uint8)2;	/* nbr bytes utiles */

  command[2] = (uint8)'H';
  command[3] = (uint8)0;
  do
    {
      tim_suspend_task(20);
      status = msg_send_message(command, 4);
    }
  while(status!=0); 

  do
    {
      status = msg_receive_message(response, 2); 
    }
  while(status!=0); 

  return (int32)response[1];
}


boolean elevate(elevation, delta_e, timout_e)
int32 elevation, delta_e, timout_e;			/* timout in ms */
{
  uint8 command[50], response[50];
  int32 status, st_op;
  int diff;

  command[0] = (uint8)1;	/* ID tourelle */
  command[1] = (uint8)2;	/* nbr bytes utiles */

  command[2] = (uint8)'E';
  command[3] = (uint8)elevation;
  do
    {
      tim_suspend_task(20); 
      status = msg_send_message(command, 4);
    }
  while(status!=0); 

  do
    {
      tim_suspend_task(20); 
      status = msg_receive_message(response, 1); 
    }
  while(status!=0); 

  st_op = tim_get_ticcount();

  while(( (diff = iabs(get_elevation()-elevation)) >delta_e)&&((tim_get_ticcount()-st_op)<timout_e));
  {
    tim_suspend_task(50);
  }
    
  printf("dest: %ld, elev: %ld, st_op: %ld, tic: %ld\n",elevation,get_elevation(),st_op,tim_get_ticcount());
  
  if(diff <= delta_e)
    {
      printf("diff: %d\n",diff);
      return(TRUE);
    }
  else
    {
      printf("diff: %d\n",diff);
      return(FALSE);
    }
}

boolean elevate_new(elevation, delta_e, timout_e)
int32 elevation, delta_e, timout_e;			/* timout in ms */
{
  uint8 command[50], response[50];
  int32 status, st_op;

  if(get_elevation() > elevation && elevation > 100)
    delta_e *= -1;
  else if (get_elevation()< elevation && elevation < 120)
    {}
  else delta_e = 0;
    
  command[0] = (uint8)1;	/* ID tourelle */
  command[1] = (uint8)2;	/* nbr bytes utiles */

  command[2] = (uint8)'E';
  command[3] = (uint8)(elevation + delta_e);
  do
    {
      tim_suspend_task(20); 
      status = msg_send_message(command, 4);
    }
  while(status!=0); 

  do
    {
      tim_suspend_task(20); 
      status = msg_receive_message(response, 1); 
    }
  while(status!=0); 

  st_op = tim_get_ticcount();

  if(delta_e)			/* delta_e !=0 */
    {
    if(delta_e > 0) 
      {
      while(get_elevation() < elevation)
	tim_suspend_task(50);
      }
    else			/* delta_e < 0 */
      {
      while(get_elevation() > elevation)
	tim_suspend_task(50);
      }
    }
  else  
    while(iabs(get_elevation()-elevation) > 10 &&
	  ((tim_get_ticcount()-st_op)<timout_e))
      tim_suspend_task(50);


  command[0] = (uint8)1;	/* ID tourelle */
  command[1] = (uint8)2;	/* nbr bytes utiles */

  command[2] = (uint8)'E';
  command[3] = (uint8)elevation;
  do
    {
      tim_suspend_task(20); 
      status = msg_send_message(command, 4);
    }
  while(status!=0); 

  do
    {
      tim_suspend_task(20); 
      status = msg_receive_message(response, 1); 
    }
  while(status!=0); 

  tim_suspend_task(100);
  
  printf("dest: %ld, elev: %ld, st_op: %ld, tic: %ld\n",elevation,get_elevation(),st_op,tim_get_ticcount()); 	

  if( iabs(elevation-get_elevation()) < 10)
    return(TRUE);
  else
    return(FALSE);
}


boolean grip(serrage, delta_s, timout_s)
int32 serrage, delta_s, timout_s;
{
  uint8 command[50], response[50];
  int32 status, st_op, serrage_old;
  
  /* serre la pince */
  command[0] = (uint8)1;
  command[1] = (uint8)2;
  command[2] = (uint8)'D';
  command[3] = (uint8)255;
  do
    {
      status = msg_send_message(command, 4);
    }
  while(status!=0); 

  do

    {
      status = msg_receive_message(response, 1);
    }
  while(status!=0); 
  
  st_op = tim_get_ticcount();

  tim_suspend_task(200);
  do
    {
      serrage_old = get_serrage();
      tim_suspend_task(100);
    }
  while((iabs(get_serrage()-serrage)>delta_s)&&((tim_get_ticcount()-st_op)<timout_s)
	&& iabs(serrage_old-get_serrage())>10 );
    
  /*  printf("dest: %ld, serrage: %ld, serrage_old: %ld, st_op: %ld, tic: %ld\n",serrage,get_serrage(),serrage_old,st_op,tim_get_ticcount()); */
  
  if(iabs(get_serrage()-serrage)<delta_s)
    return(TRUE);
  else
    return(FALSE);

}


void degrip()
{
  uint8 command[50], response[50];
  int32 status;
  
  /* ouvre la pince */

  command[0] = (uint8)1;
  command[1] = (uint8)2;
  command[2] = (uint8)'D';
  command[3] = (uint8)0;
  do
    {
      status = msg_send_message(command, 4);
    }
  while(status!=0); 

  do
    {
      status = msg_receive_message(response, 1);
    }
  while(status!=0); 
}


boolean check_grip_full()
{
  uint8 command[50], response[50];
  int32 tmp_gripped, status;

  /* observe si object dans pince */
  command[0] = (uint8)1;
  command[1] = (uint8)1;
  command[2] = (uint8)'G';
  do
    {
      status = msg_send_message(command, 3);
    }
  while(status!=0); 

  do
    {
      status = msg_receive_message(response, 2);
    }
  while(status!=0);

  tmp_gripped = (int32)response[1];
  
  if(tmp_gripped == 0x00)
    return FALSE;
  else
    return TRUE;
    
}



void turn(turn_angle)
int32 turn_angle;
{
  int32         old_mot, tmp_angle;

  if(turn_angle != 0)
    {

      old_mot = mot_get_position(0);

      /* start rotation */
      if(sign(turn_angle) == -1)
	{
	  mot_new_speed_pid(0, -ROTATION_SPEED);
	  mot_new_speed_pid(1, ROTATION_SPEED);
	}
      else
	if(sign(turn_angle) == 1)
	  {
	    mot_new_speed_pid(0, ROTATION_SPEED);
	    mot_new_speed_pid(1, -ROTATION_SPEED);
	  }

      do
	{
	  tmp_angle = (((mot_get_position(0) - old_mot)*5)/K_RADIUS); /* 360/6.28/12 = 4.78 */

	}
      while(iabs(tmp_angle - turn_angle) > 5); /* FM says 1 degrees is OK!!! */

      mot_new_speed_pid(0, 0);
      mot_new_speed_pid(1, 0);
    }
}


int move(distance,timout_e)
int32 distance, timout_e; 		/* timout in ms */
{
  int err = 0;
  int32 old_mot;
  int32 st_op;
 
  if(distance != 0)
    {

      old_mot = mot_get_position(0);

      /* start moving */
      if(sign(distance) == -1)
	{
	  mot_new_speed_pid(0, -APPROACH_SPEED);
	  mot_new_speed_pid(1, -APPROACH_SPEED);
	}
      else
	{
	  mot_new_speed_pid(0, APPROACH_SPEED);
	  mot_new_speed_pid(1, APPROACH_SPEED);
	}

      st_op = tim_get_ticcount();

      do
	{
	  if (sign(distance) == -1 && (sens_get_reflected_value(6) >= 1023 || 
				       sens_get_reflected_value(7) >= 1023))
	    {
	      err = -1;
	      break;
	    }
	  else if (sign(distance) == 1 && (sens_get_reflected_value(2) >= 1023 || 
					   sens_get_reflected_value(3) >= 1023))
	    {
	      err = 1;
	      break;
	    }

	  if( tim_get_ticcount() - st_op  > timout_e )
	    {
	      err = 2;
	      break;
	    }
	}
      while(iabs(mot_get_position(0) - old_mot) < iabs(distance));      
    
      mot_new_speed_pid(0, 0);
      mot_new_speed_pid(1, 0);

      /*      printf("Moved: %ld of %ld \n",
	      iabs(mot_get_position(0) - old_mot) , iabs(distance) );*/

      return err;
    }
  return 3;
}
