			llen		80

; Start code.
; ===========

;------------------------------------------------------------------------
; Author:	Franzi Edo.	le 21/10/96
; Modifs:
;
; Project:	KHEPERA
; Goal:		Start code; copy initialised data from ROM to RAM.
;
;------------------------------------------------------------------------

			lib			:::::Common:macro.s
			lib			::::Includes:mapping.s

KREVISION	equ			"1.00"				; revision

KIDMODULE	equ 		(kIDFunction<<16)+("U"<<8)+"A"	; module ID

			section		.text
			import		stRAM,stEPROM,lnRAM,lnEPROM

__start:	bra			start				; jump to the module
			dc.w		0					; !!! "bra start" is only 2 bytes
			dc.l		KIDMODULE			; ID of the module
			dc.l		stEPROM				; Ptr on the CODE segment
			dc.l		lnEPROM				; lenght of the CODE segment
			dc.l		stRAM				; Ptr on the DATA segment
			dc.l		lnRAM				; lenght of the DATA segment
			dc.l		aApplication-*		; Ptr on the string
			dc.l		KREVISION			; revision
			dc.l		aStrHelp-*			; Ptr on the help string
			dc.l		1<<bExecSerCom		; executable from SerCom
			dc.l		0					; Ptr on the process descriptor
			dc.l		0					; reserve 2
			dc.l		0					; reserve 1

; Copy the non-constant static & global initialized data to RAM.
; Symbols used:
;
; __datastart	- destination address
; __initstart	- source address
; __initend		- address following the source BLOCK

			section		.text
			import		__datastart,__initstart,__initend
			import		__bssstart,__bssend
			import		__main,tim_get_id,kill_task,tim_remove_inst_task

start:		lea.l		__initstart,A0		; Ptr on the source data
			lea.l		__datastart,A1		; Ptr on the destination data
			move.l		#__initend,D0		;
			sub.l		A0,D0				; size of the data
111			move.b		(A0)+,(A1)+			; copy an element
			sub.l		#1,D0				; 
			bne			111s				; next

; Clear the uninitialized RAM area.  This is required (mainly
; for C) so that uninitialized variables have a value of 0.
; Symbols used:
;
; __bssstart	- low address of the ".bss" area
; __bssend		- address following the ".bss" area

			lea.l		__bssstart,A0		; Ptr on the start source data
			move.l		#__bssend,D0		; Ptr on the end source data
			sub.l		A0,D0				; size of the data
222			clr.b		(A0)+				; clear an element
			sub.l		#1,D0				; 
			bne			222s				; next

; Go to the C code
; ----------------

			sub.l		fp,fp					; terminate the stack frame linked list
			jsr			__main					;

; Terminate the main, the task "father" is killed.

			jsr			tim_get_id				;
			move.l		D0,-(SP)				;
			jsr			tim_remove_inst_task	;
			add.l		#4,SP					; 
333			bra			333s					;

; Terminate a task by an "exit".

__exit:		jsr			tim_get_id			;
			move.l		D0,-(SP)			;
			jsr			kill_task			;
			add.l		#4,SP				; 
444			bra			444s

HALT:		or			#$700,sr			; mask interrupt
555			bra			555s				; loop forever

; Module strings
; ==============

aApplication:

;------------------------|------------|------------------------------------------------|
			dc.b		'user         User romable C program, EF-98:                   Rev. '
			dc.l		KREVISION			; revision
			dc.b		CR,LF,NULL			; CR + LF + \0

aStrHelp:

;------------------------|----------|-------------------------------------------|
			dc.b		CR,LF
			dc.b		'This is a romable C application',CR,LF
			dc.b		'===============================',CR,LF,LF

			dc.b		'This user function module is a C written application.',CR,LF,LF

			dc.b		'Input format:  run user',CR,LF
			dc.b		'Output format: comment',CR,LF,LF

			dc.b		'Output line is terminated with CRLF.',CR,LF,LF
    
			COPY_RIGHT_FRANZI

			end

