/**************************************************************************
Project name	:	binapp.c
Purpose			:	Append two binary files, the second having a 32 bytes header
					removed during the append operation
Creation date	:	12/12/97
Author			:	F. Mondada
***************************************************************************/

#include <stdio.h>

#define L_PAQUET 100
#define L_ENTETE 32

enum { ARG_FILENAME_IN1 = 1, ARG_FILENAME_IN2 = 2, ARG_FILENAME_OUT = 3, ARG_COUNT };

/* ******************************************************************** */
/* ******************************************************************** */

int main(argc,argv)
  long argc;
  char *argv[];
  {
  FILE *f_in1, *f_in2, *f_out;
  char	buffer[L_PAQUET], entete[L_ENTETE];
  long	lr_size, lw_size;
  
  if ((argc != ARG_COUNT))
    {
    fprintf(stderr,"Usage: %s bin_filename_in1 bin_filename_in2 bin_filename_in1+2\n", argv[0]);
    exit(1);
    }
  if ((f_in1 = fopen(argv[ARG_FILENAME_IN1], "r")) == NULL)
    {
    fprintf(stderr, "File %s not found\n", argv[ARG_FILENAME_IN1]);
    exit(1);
    }

  if ((f_in2 = fopen(argv[ARG_FILENAME_IN2], "r")) == NULL)
    {
    fprintf(stderr, "File %s not found\n", argv[ARG_FILENAME_IN2]);
    exit(1);
    }

  if ((f_out = fopen(argv[ARG_FILENAME_OUT], "w")) == NULL)
    {
    fprintf(stderr, "Could not write in %s, check write access\n", 
    	argv[ARG_FILENAME_OUT]);
    exit(1);
    } 

  do
    {
    lr_size = fread(buffer, 1, L_PAQUET, f_in1);
    lw_size = fwrite(buffer, 1, lr_size, f_out);	/* data */
    }
  while(!feof(f_in1));

  fclose(f_in1);

  if( (fread(entete, L_ENTETE, 1, f_in2)) != 1)		/* cut the header! */
    {
    fprintf(stderr, "Header of %s not readable\n", argv[ARG_FILENAME_IN2]);
    fclose(f_in2);
    fclose(f_out);
    exit(1);
    }
    
  do
    {
    lr_size = fread(buffer, 1, L_PAQUET, f_in2);
    lw_size = fwrite(buffer, 1, lr_size, f_out);	/* data */
    }
  while(!feof(f_in2));

  fclose(f_in2);
  fclose(f_out);

  return 0;
  }
