/**************************************************************************
Project name	:	bpunch.c
Purpose		:	Take a .code file and delete the header
Creation date	:	24/11/92
Author		:	F. Mondada
History.	:	F. Mondada	no gen_types
***************************************************************************/

#include <stdio.h>

#define L_PAQUET 100
#define L_ENTETE 256

enum { ARG_FILENAME = 1, ARG_DEVICE = 2, ARG_COUNT };

/* ******************************************************************** */
/* ******************************************************************** */

int main(argc,argv)
  long argc;
  char *argv[];
  {
  FILE *f_in, *f_out;
  char	buffer[L_PAQUET], entete[L_ENTETE];
  long	lr_size, lw_size;
  
  if ((argc != ARG_COUNT))
    {
    fprintf(stderr,"Usage: %s code_filename bin_filename\n", argv[0]);
    exit(1);
    }
  if ((f_in = fopen(argv[ARG_FILENAME], "r")) == NULL)
    {
    fprintf(stderr, "File %s not found\n", argv[ARG_FILENAME]);
    exit(1);
    }

if ((f_out = fopen(argv[ARG_DEVICE], "w")) == NULL)
    {
    fprintf(stderr, "Could not write in %s, check write access\n", 
    	argv[ARG_DEVICE]);
    exit(1);
    } 

  if( (fread(entete, L_ENTETE, 1, f_in)) != 1)		/* cut the header! */
    {
    fprintf(stderr, ".code Header not readable\n");
    fclose(f_in);
    fclose(f_out);
    exit(1);
    }

  do
    {
    lr_size = fread(buffer, 1, L_PAQUET, f_in);
    lw_size = fwrite(buffer, 1, lr_size, f_out);	/* data */
    }
  while(!feof(f_in));

  fclose(f_in);
  fclose(f_out);

  return 0;
  }
