/**************************************************************************
Project name	:	precross.c
Purpose		:	Modify a .code file for downloading
Creation date	:	17/08/92
Author		:	Y. Cheneval
History.	:	18/08/92:	Added some tests to f...() calls
		:	F. Mondada	no gen_types
***************************************************************************/

#include <stdio.h>

enum { ARG_FILENAME = 1, ARG_COUNT };

/* ******************************************************************** */
/* ******************************************************************** */

int main(argc,argv)
  long argc;
  char *argv[];
  {
  FILE *fp;
  char	*buffer;
  long	size;
  
  if ((argc != ARG_COUNT))
    {
    fprintf(stderr,"Usage: %s filename\n", argv[0]);
    exit(1);
    }
  if ((fp = fopen(argv[ARG_FILENAME], "r")) == NULL)
    {
    fprintf(stderr, "File %s not found\n", argv[ARG_FILENAME]);
    exit(1);
    }
  fseek(fp, 0L, 2);
  size = ftell(fp);
  rewind(fp);
  if ((buffer = (char *)malloc(size)) == NULL)
    {
    fprintf(stderr,"Not enough memory\n");
    exit(1);
    }
  if (fread(buffer, size, 1, fp) != 1)
    {
    fprintf(stderr,"fread() didn't succeed\n");
    fclose(fp);
    free(buffer); 
    exit(1);
    }
  fclose(fp);
  memcpy(buffer+264, buffer+0x64, 12);
  if ((fp = fopen(argv[ARG_FILENAME], "w")) == NULL)
    {
    fprintf(stderr, "Could not create file %s, check write access\n", 
    	argv[ARG_FILENAME]);
    free(buffer); 
    exit(1);
    } 
  if (fwrite(buffer, size, 1, fp) != 1)
    fprintf(stderr, "fwrite() failed, your file is lost...\n");
  fclose(fp);
  free(buffer);
  return 0;
  }
