/*
 *	CTYPE.H		Character classification and conversion
 */

#ifndef _CTYPE_H
#define _CTYPE_H

extern	unsigned char	_ctype[];
extern	int		toupper	(int c);	/* including Smaky codes */
extern	int		tolower	(int c);

#define	_CTc	0x01	/* control character */
#define	_CTd	0x02	/* numeric digit */
#define	_CTu	0x04	/* upper case */
#define	_CTl	0x08	/* lower case */
#define	_CTs	0x10	/* whitespace */
#define	_CTp	0x20	/* punctuation */
#define	_CTx	0x40	/* hexadecimal */
#define	_CTa	0x80	/* letter with accent, Smaky: 15..29 */

#define	isalnum(c)	((_ctype+1)[c]&(_CTu|_CTl|_CTd))
#define	isalpha(c)	((_ctype+1)[c]&(_CTu|_CTl))
#define	isascii(c)	!((c)&~0x7F)
#define	iscntrl(c)	((_ctype+1)[c]&_CTc)
#define	isdigit(c)	((_ctype+1)[c]&_CTd)
#define	isgraph(c)	!((_ctype+1)[c]&(_CTc|_CTs))
#define	islower(c)	((_ctype+1)[c]&_CTl)
#define	isprint(c)	!((_ctype+1)[c]&_CTc)
#define	ispunct(c)	((_ctype+1)[c]&_CTp)
#define	isspace(c)	((_ctype+1)[c]&_CTs)
#define	isupper(c)	((_ctype+1)[c]&_CTu)
#define	isxdigit(c)	((_ctype+1)[c]&_CTx)
#define	isaccent(c)	((_ctype+1)[c]&_CTa)

/* following macros are not possible on Smaky because of codes 15..29:
#define	toupper(c)	(islower(c)?(c)^0x20:(c))
#define	tolower(c)	(isupper(c)?(c)^0x20:(c))
#define	_toupper(c)	((c)^0x20)
#define	_tolower(c)	((c)^0x20)*/

#define	toascii(c)	((c)&0x7F)

#endif	/* _CTYPE_H */

