/*
 *	FLOAT.H
 */

#ifndef	_FLOAT_H
#define	_FLOAT_H

#define FLT_RADIX		2	/* base of exponent representation */
#define FLT_ROUNDS		1	/* rounding mod */
/*#define FLT_GUARD		1	*/
/*#define FLT_NORMALIZE		1	*/

/* FLT = float, DBL = double */
#define DBL_DIG			15	/* precision in decimal digits */
#define FLT_DIG			6

#define DBL_MANT_DIG		53	/* bits for mantissa */
#define FLT_MANT_DIG		24

#define DBL_EPSILON		2.2204460492503131E-16	/* 1.0 + x <> 1.0 */
#define FLT_EPSILON		1.19209290E-07F

/* smallest positive IEEE normal numbers */
#define DBL_MIN			2.2250738585072014E-308
#define FLT_MIN			1.17549435E-38F

/* biggest positive IEEE normal numbers */
#define DBL_MAX			1.79769E+308
#define FLT_MAX			3.4028234E+38F

#define DBL_MAX_EXP		+1024	/* max. exponent, FLT_RADIX**x - 1 */
#define FLT_MAX_EXP		+128

#define DBL_MAX_10_EXP		+308	/* max. exponent, 10**x */
#define FLT_MAX_10_EXP		+38

#define DBL_MIN_10_EXP		-307	/* min. exponent, 10**x */
#define FLT_MIN_10_EXP		-37

#define DBL_MIN_EXP		-1021	/* min. exponent, FLT_RADIX**n */
#define FLT_MIN_EXP		-125

#endif	/* _FLOAT_H */

