/*
 *	STRING.H	String function declarations
 */

#ifndef _STRING_H
#define	_STRING_H

/* need size_t */
#include <stddef.h>

/* aliases */
#define	streq	!strcmp
#define	strneq	!strncmp
#define	strcmpi(s1,s2)		stricmp(s1,s2)
#define	strncmpi(s1,s2,n)	strnicmp(s1,s2,n)

extern	int	bcmp	(const void *b1, const void *b2, size_t n);
extern	void	bcopy	(const void *source, void *dest, size_t n);
extern	void	bzero	(void *dest, size_t n);
extern	char	*index	(const char *source, int c);
extern	char	*rindex	(const char *source, int c);
extern	void	*memmove(void *dest, const void *source, size_t n);
extern	char	*memcpy	(char *dest, char *source, int n);
extern	void	*memccpy(void *dest, const void *source, int c, size_t n);
extern	void	*memset	(void *s, int c, size_t n);
extern	int	memcmp	(const void *src1, const void *src2, size_t n);
extern	int	memicmp	(const void *src1, const void *src2, size_t n);
extern	void	*memchr	(const void *s, int c, size_t n);
extern	size_t	strlen	(const char *source);
extern	char	*strcpy	(char *dest, const char *source);
extern	char	*strncpy(char *dest, const char *source, size_t n);
extern	char	*strpcpy(char *dest, const char *start, const char *stop);
extern	char	*strdup	(const char *source);
extern	char	*strset	(char *dest, int c);
extern	char	*strnset(char *dest, int c, size_t n);
extern	char	*substr	(char *dest, const char *source, int start, int end);
extern	char	*subnstr(char *dest, const char *source, int start, int length);
extern	char	*strcat	(char *dest, const char *source);
extern	char	*strncat(char *dest, const char *source, size_t n);
extern	char	*strupr	(char *string);
extern	char	*strlwr	(char *string);
extern	char	*strrev	(char *string);
extern	int	strcmp	(const char *source1, const char *source2);
extern	int	strncmp	(const char *source1, const char *source2, size_t n);
extern	int	stricmp	(const char *source1, const char *source2);
extern	int	strnicmp(const char *source1, const char *source2, size_t n);
extern	char	*strstr	(const char *string, const char *pattern);
extern	char	*stristr(const char *string, const char *pattern);
extern	char	*strchr	(const char *source, int c);
extern	char	*strrchr(const char *source, int c);
extern	int	strpos	(const char *source, int c);
extern	int	strrpos	(const char *source, int c);
extern	size_t	strspn	(const char *string, const char *set);
extern	size_t	strcspn	(const char *string, const char *set);
extern	char	*strpbrk(const char *string, const char *set);
extern	char	*strrpbrk(const char *string, const char *set);
extern	char	*strtok	(char *string, const char *set);
extern	char	*strtrim(char *string, const char *junk);
extern	char	*stradj	(char *string, int dir);
extern	int	strrpl	(char *string, const char *ptrn, const char *rpl, int n);
extern	int	strirpl	(char *string, const char *ptrn, const char *rpl, int n);

extern	char	*ltoa	(long value, char *string, int radix);
extern	char	*ultoa	(unsigned long value, char *string, int radix);
extern	char	*itoa	(int value, char *string, int radix);
extern	long	strtol	(const char *source, char **endptr, int radix);
extern	unsigned long strtoul(const char *source, char **endptr, int radix);

#endif	/* _STRING_H */

